#require './plato'

class Menu 

    attr_accessor :titulo, :ingestaPor, :platos, :valorCT, :porcentajePro, :porcentajeGra, :porcentajeHid #geters y serters asi nos ahorramos escribirlo 
    
    include Comparable
    
    def initialize(titulo, ingestaPor, platos, valorCT, porcentajePro, porcentajeGra, porcentajeHid)
        @titulo         = titulo
        @ingestaPor     = ingestaPor
        @platos         = platos
        @valorCT        = valorCT
        @porcentajePro  = porcentajePro
        @porcentajeGra  = porcentajeGra
        @porcentajeHid  = porcentajeHid
    end

    
    def getPlato(pos)
        
        if(pos-1 >= platos.length || pos-1 < 0)
            return (puts "Error posicion no valida")
        end
        
        if(pos-1 < platos.length)
            return platos[pos-1]
        end

    end
    
    def getConjPlatos
        return platos
    end
    
    def <=> (otro)
        return nil unless otro.is_a?Menu #Si el otro objeto no es del tipo menu devuelve nil
        if (@valorCT[0] == otro.valorCT[0])
            if(@platos.length == otro.platos.length)
                return 0
            else
                if(@platos.length < otro.platos.length)
                    return -1
                end
                return 1
            end
        else
            if(@valorCT[0] < otro.valorCT[0])
                return -1
            end
            return 1
        end
    end
    
    def ==(otro)
       if otro.is_a?Menu
            @titulo == otro.titulo &&
            @ingestaPor == otro.ingestaPor &&
            @platos == otro.platos &&
            @valorCT == otro.valorCT &&
            @porcentajePro == otro.porcentajePro &&
            @porcentajeGra == otro.porcentajeGra &&
            @porcentajeHid == otro.porcentajeHid
        else
            false
        end 
    end
    
    def to_s
        string = "#{@titulo} (" 
        
        @ingestaPor.each_with_index do |elem,i| 
            if(i==1)
                string+=" - "
            end
            string+= "#{elem}"
        end 
        string+="%)\n"

         @platos.each_with_index do |elem,i|
            string+="- #{elem.to_s}\n"
         end
   
        string+="V.C.T. | % #{valorCT[0]} #{valorCT[1]} | #{porcentajePro}% - #{porcentajeGra}% - #{porcentajeHid}%"
        
        return string
    end

end


   